
/**
 * Demonstrace algoritmu QuickSort.
 */
public class QuickSort {

    /**
     * Pole, které se řadí.
     */
    private IntArray array;

    /**
     * Vytvoří novou instanci třídy QuickSort.
     *
     * @param array
     *            pole, které se bude řadit.
     */
    public QuickSort(IntArray array) {
        this.array = array;
    }

    /**
     * Seřadí vzestupně pole pomocí algoritmu QuickSort.
     */
    public void sort() {
        quickSortHelper(0, this.array.size() - 1);
    }

    /**
     * Seradi interval v poli array od indexu from do indexu to
     * 
     * @param from index prvniho prvku z razeneho intervalu
     * @param to index posledniho prvku z razeneho intervalu
     */
    private void quickSortHelper(int from, int to) {
        if (from >= to) {
            return;
        }

        int pivot = from;
        int right = to + 1;
        int left = from;
        do {
            while (array.get(--right) >= array.get(pivot) && right > pivot);
            swap(pivot, right, from, to);
            pivot = right;
            while (left < pivot && array.get(++left) <= array.get(pivot));
            swap(pivot, left, from, to);
            pivot = left;
        }  while (right > left);
        quickSortHelper(from,pivot-1);
        quickSortHelper(pivot+1,to);
    }

    private void swap(int pivot, int index, int from, int to) {
        if (pivot == index) {
            return;
        }
        array.swap(pivot, index);
        printPass(pivot, index, from, to);
    }

    /**
     * Pomocná metoda pro tisk jednoho průchodu algoritmu.
     *
     */
    private void printPass(int pivot, int index, int from, int to) {
        System.out.printf("          %2d-%2d: ",from,to);
        for (int i = 0; i < array.size(); i++) {
            if (i < from || i > to) {
                System.out.print("    ");
            } else if (i == pivot) {
                System.out.printf("[%2d]", array.get(i));
            } else if (i == index) {
                System.out.printf("*%2d*", array.get(i));
            } else {
                System.out.printf(" %2d ", array.get(i));
            }
        }
        System.out.println();
    }
}
